lorom
table table.tbl

;    <map mode="linear" address="00-6f:8000-ffff"/>
;    <map mode="linear" address="80-ff:8000-ffff"/>

;RAM map:
;$00 through $0C: Same values as in the S-RTC. See notes below.
;$10: Current slot the cursor is on.
;$13: Frame counter.
;$15 through $18: Same as in SMW. Ask AlcaRobot or the RAM map.

;S-RTC info:
;To enable in zsnes and snes9x (untested):
;org $00FFD5 : db $35,$55
;
;To enable in bsnes: Check the XML file. It should be obvious what to do.
;
;To set the clock:
;write 0E to $2801
;write 00 to $2801
;write S-RTC RAM to $2801 (note that weekday is automatically calculated)
;
;To read the clock:
;write 0D to $2801
;read garbage byte (0F) from $2800
;read S-RTC RAM from $2800
;
;S-RTC "RAM" (data read and written):
;ones of seconds
;tens of seconds
;ones of minutes
;tens of minutes
;ones of hours
;tens of hours
;ones of day
;tens of day
;month
;ones of year
;tens of year
;hundreds of year
;weekday

Reset:

SEI
STZ $4200
STZ $420C
STZ $420B
STZ $2140
STZ $2141
STZ $2142
STZ $2143
LDA #$80
STA $2100
CLC
XCE
REP #$38
LDA #$0000
TCD
LDA #$01FF
TCS

PHK
PLB

JSR Init

LDA.b #%10000000
STA $2115
REP #$20
LDA #$0000
STA $2116
LDA.w #$1801
STA $4300
LDA.w #Font
STA $4302
LDY.b #Font/65536;copy graphics
STY $4304
LDA.w #$0800
STA $4305
SEP #$20
LDY #$01
STY $420B

LDA.b #%00000000
STA $2115
REP #$20
LDA #$1000
STA $2116
LDA.w #$1800
STA $4300
LDA.w #Tilemap
STA $4302
LDY.b #Tilemap/65536;copy tilemap
STY $4304
LDA.w #$0380
STA $4305
SEP #$20
LDY #$01
STY $420B

LDA.b #%10000000
STA $2115
REP #$20
LDA #$1000
STA $2116
LDA.w #$1908
STA $4300
LDA.w #Zero
STA $4302
LDY.b #Zero/65536;clear yxppcccts
STY $4304
LDA.w #$0380
STA $4305
SEP #$20
LDY #$01
STY $420B

STZ $13;I'm used to 13 being the frame counter.
LDA $4210
Nextframe1:
LDA #$80
STA $2100;I'll run everything in the vblank.
INC $13

LDA $13
LSR #3
AND #$03
TAX

macro Color(color)
INX
CPX #$05
BNE ?Nope
LDX #$01
?Nope:
STX $2121
LDA.b #<color>
STA $2122
LDA.b #<color>/256
STA $2122
endmacro

%Color($7FFF)
%Color($7FF9)
%Color($7FD0)
%Color($6AE9)

;;copy time data
;LDA.b #%00000000
;STA $2115
;STZ $2116
;LDA #$10
;STA $2117
;
;LDA #$0D
;STA $2801
;LDX #$0F
;-
;LDA $2800
;STA $2118
;DEX
;BPL -

;This updates the controller.
.WaitForController
LDA $4212
AND #$01
BNE .WaitForController
LDA $4218
AND #$F0
STA $0DA4
TAY
EOR $0DAC
AND $0DA4
STA $0DA8
STY $0DAC
LDA $4219
STA $0DA2
TAY
EOR $0DAA
AND $0DA2
STA $0DA6
STY $0DAA

LDA $0DA4
AND #$C0
ORA $0DA2
STA $15
LDA $0DA4
STA $17
LDA $0DA8
AND #$40
ORA $0DA6
STA $16
LDA $0DA8
STA $18

LDA #$0F
STA $2100
.CheckNextFrame
LDA $4210
BPL .CheckNextFrame
JMP Nextframe1

Font:
incbin font.bin

Tilemap:
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "      2010-01-01 00:00:00       "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "
db "                                "

Zero:
db $00

Init:
	sep 	#$30    ; X,Y,A are 8 bit numbers
	lda 	#$8F    ; screen off, full brightness
	sta 	$2100   ; brightness + screen enable register 
	stz 	$2101   ; Sprite register (size + address in VRAM) 
	stz 	$2102   ; Sprite registers (address of sprite memory [OAM])
	stz 	$2103   ;    ""                       ""
lda #$01
sta $2105;I want mode1, not mode0.
;	stz 	$2105   ; Mode 0, = Graphic mode register
	stz 	$2106   ; noplanes, no mosaic, = Mosaic register
lda #$10
sta $2107;My Layer 1 tilemap is at $1000, not $0000. Why would the L1 tilemap overlap its own graphics space anyways?
;	stz 	$2107   ; Plane 0 map VRAM location
	stz 	$2108   ; Plane 1 map VRAM location
	stz 	$2109   ; Plane 2 map VRAM location
	stz 	$210A   ; Plane 3 map VRAM location
	stz 	$210B   ; Plane 0+1 Tile data location
	stz 	$210C   ; Plane 2+3 Tile data location
	stz 	$210D   ; Plane 0 scroll x (first 8 bits)
	stz 	$210D   ; Plane 0 scroll x (last 3 bits) #$0 - #$07ff
lda #$ff
sta $210E;drop that strange pixel
;	stz 	$210E   ; Plane 0 scroll y (first 8 bits)
lda #$07
sta $210E
;	stz 	$210E   ; Plane 0 scroll y (last 3 bits) #$0 - #$07ff
	stz 	$210F   ; Plane 1 scroll x (first 8 bits)
	stz 	$210F   ; Plane 1 scroll x (last 3 bits) #$0 - #$07ff
	stz 	$2110   ; Plane 1 scroll y (first 8 bits)
	stz 	$2110   ; Plane 1 scroll y (last 3 bits) #$0 - #$07ff
	stz 	$2111   ; Plane 2 scroll x (first 8 bits)
	stz 	$2111   ; Plane 2 scroll x (last 3 bits) #$0 - #$07ff
	stz 	$2112   ; Plane 2 scroll y (first 8 bits)
	stz 	$2112   ; Plane 2 scroll y (last 3 bits) #$0 - #$07ff
	stz 	$2113   ; Plane 3 scroll x (first 8 bits)
	stz 	$2113   ; Plane 3 scroll x (last 3 bits) #$0 - #$07ff
	stz 	$2114   ; Plane 3 scroll y (first 8 bits)
	stz 	$2114   ; Plane 3 scroll y (last 3 bits) #$0 - #$07ff
	lda 	#$80    ; increase VRAM address after writing to $2119
	sta 	$2115   ; VRAM address increment register
	stz 	$2116   ; VRAM address low
	stz 	$2117   ; VRAM address high
	stz 	$211A   ; Initial Mode 7 setting register
	stz 	$211B   ; Mode 7 matrix parameter A register (low)
	lda 	#$01
	sta 	$211B   ; Mode 7 matrix parameter A register (high)
	stz 	$211C   ; Mode 7 matrix parameter B register (low)
	stz 	$211C   ; Mode 7 matrix parameter B register (high)
	stz 	$211D   ; Mode 7 matrix parameter C register (low)
	stz 	$211D   ; Mode 7 matrix parameter C register (high)
	stz 	$211E   ; Mode 7 matrix parameter D register (low)
	sta 	$211E   ; Mode 7 matrix parameter D register (high)
	stz 	$211F   ; Mode 7 center position X register (low)
	stz 	$211F   ; Mode 7 center position X register (high)
	stz 	$2120   ; Mode 7 center position Y register (low)
	stz 	$2120   ; Mode 7 center position Y register (high)
	stz 	$2121   ; Color number register ($0-ff)
	stz 	$2123   ; BG1 & BG2 Window mask setting register
	stz 	$2124   ; BG3 & BG4 Window mask setting register
	stz 	$2125   ; OBJ & Color Window mask setting register
	stz 	$2126   ; Window 1 left position register
	stz 	$2127   ; Window 2 left position register
	stz 	$2128   ; Window 3 left position register
	stz 	$2129   ; Window 4 left position register
	stz 	$212A   ; BG1, BG2, BG3, BG4 Window Logic register
	stz 	$212B   ; OBJ, Color Window Logic Register (or,and,xor,xnor)
	sta 	$212C   ; Main Screen designation (planes, sprites enable)
	stz 	$212D   ; Sub Screen designation
	stz 	$212E   ; Window mask for Main Screen
	stz 	$212F   ; Window mask for Sub Screen
	lda 	#$30
	sta 	$2130   ; Color addition & screen addition init setting
	stz 	$2131   ; Add/Sub sub designation for screen, sprite, color
	lda 	#$E0
	sta 	$2132   ; color data for addition/subtraction
	stz 	$2133   ; Screen setting (interlace x,y/enable SFX data)
lda #$01
sta $4200;enable auto joypad read
;	stz 	$4200   ; Enable V-blank, interrupt, Joypad register
	lda 	#$FF
	sta 	$4201   ; Programmable I/O port
	stz 	$4202   ; Multiplicand A
	stz 	$4203   ; Multiplier B
	stz 	$4204   ; Multiplier C
	stz 	$4205   ; Multiplicand C
	stz 	$4206   ; Divisor B
	stz 	$4207   ; Horizontal Count Timer
	stz 	$4208   ; Horizontal Count Timer MSB (most significant bit)
	stz 	$4209   ; Vertical Count Timer
	stz 	$420A   ; Vertical Count Timer MSB
	stz 	$420B   ; General DMA enable (bits 0-7)
	stz 	$420C   ; Horizontal DMA (HDMA) enable (bits 0-7)
	stz 	$420D	; Access cycle designation (slow/fast rom)
;	cli 	 	; Enable interrupts
	rts





STA $7F0D01
LDA $213D
STA $7F0D00
LDA $7F0D01
AND #$F0
LSR #4
STA $0EF9
LDA $7F0D01
AND #$0F
STA $0EFA
LDA $7F0D00
AND #$F0
LSR #4
STA $0EFB
LDA $7F0D00
AND #$0F
STA $0EFC









LDA $7F0D01
AND #$F0
LSR #4
STA $0EF9

LDA $7F0D01
AND #$0F
STA $0EFA

LDA $7F0D00
AND #$F0
LSR #4
STA $0EFB

LDA $7F0D00
AND #$0F
STA $0EFC

NMI:
IRQ:
Error:
LDA #$01
STA $2121
LDA #$1F
STA $2122
LDA #$00
STA $2122
LDA #$0F
STA $2100
BRK

org $00FFC0
db "S-RTC DEMO           ";name
;db $20;lorom
;db $00;no sram
db $35,$55;S-RTC doesn't seem to exist unless I set those two bytes to this
db $08;8 banks
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw Error,Error,Error;cop, brk, abort(?)
dw NMI,Error,IRQ;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw Error,Error,Error;cop, unused, abort
dw Error,Reset,Error;nmi, reset, irq/brk